package transportgrpc

import (
	"git.perx.ru/perxis/perxis-go/pkg/collections"
	"git.perx.ru/perxis/perxis-go/pkg/collections/transport"
	grpcerr "git.perx.ru/perxis/perxis-go/pkg/errors/grpc"
	pb "git.perx.ru/perxis/perxis-go/proto/collections"
	grpckit "github.com/go-kit/kit/transport/grpc"
)

func NewServer(svc collections.Collections, opts ...grpckit.ServerOption) pb.CollectionsServer {
	eps := transport.Endpoints(svc)
	eps = transport.EndpointsSet{
		CreateEndpoint:    grpcerr.ServerMiddleware(eps.CreateEndpoint),
		DeleteEndpoint:    grpcerr.ServerMiddleware(eps.DeleteEndpoint),
		GetEndpoint:       grpcerr.ServerMiddleware(eps.GetEndpoint),
		ListEndpoint:      grpcerr.ServerMiddleware(eps.ListEndpoint),
		SetSchemaEndpoint: grpcerr.ServerMiddleware(eps.SetSchemaEndpoint),
		UpdateEndpoint:    grpcerr.ServerMiddleware(eps.UpdateEndpoint),
	}
	return NewGRPCServer(&eps, opts...)
}
