package operation

import (
	"context"

	"git.perx.ru/perxis/perxis-go/proto/common"
)

type server struct {
	svc Service
	common.UnimplementedOperationServiceServer
}

func NewServer(svc Service) common.OperationServiceServer {
	return &server{
		svc: svc,
	}
}

func (s *server) Get(ctx context.Context, req *common.GetOperationRequest) (*common.Operation, error) {
	op, err := s.svc.Get(ctx, req.GetOperationId())
	if err != nil {
		return nil, err
	}
	return op.Proto(), nil
}

func (s *server) Cancel(ctx context.Context, req *common.CancelOperationRequest) (*common.Operation, error) {
	op, err := s.svc.Cancel(ctx, req.GetOperationId())
	if err != nil {
		return nil, err
	}
	return op.Proto(), nil
}
